{Checker for AMB}
Var
  Rooms     : Array[1..20] Of Integer;
  AIDS      : Array[1..20] Of (_N,_A,_B);
  N         : Integer;
  A,B       : Integer;
  BestS,S   : Integer;
  F1,F2,F3  : Text;
  Dif       : Boolean;

Procedure Done(Dif: Boolean);
  Var
    F : Text;
  Begin
    Assign(F,'$RESULT$.TXT');
    If Dif Then
             Begin
               {$I-}
               Erase(F);
               {$I+}
               If IOResult<>0 Then;
             End
           Else
             Begin
               Rewrite(F);
               WriteLn(F,ParamStr(4));
               Close(F);
             End;
    Halt;
  End;

Procedure Init;
  Begin
    Assign(F1,ParamStr(1));
    {$I-}
    Reset(F1);
    {$I+}
    If IOResult<>0 Then Done(True);
    Assign(F2,ParamStr(2));
    Reset(F2);
    Assign(F3,ParamStr(3));
    {$I-}
    Reset(F3);
    {$I+}
    If IOResult<>0 Then Done(True);
  End;

Procedure InputData;
  Var
    I,J,P,T : Integer;
  Begin
    ReadLn(F1,A);
    ReadLn(F1,B);
    ReadLn(F1,N);
    For I:=1 To N Do
      Begin
        ReadLn(F1,J,P,T);
        Rooms[I]:=J-P-T;
        AIDS[I]:=_N;
        If P<>0 Then AIDS[I]:=_A;
        If T<>0 Then AIDS[I]:=_B;
      End;

    Close(F1);

    ReadLn(F2,BestS);
    ReadLn(F2,I);
    Close(F2);

    ReadLn(F3,S);
    If S<>BestS Then Done(True);
    If I=0 Then Done(False);
  End;


Procedure CheckData;
  Var
    I,Q,W,V : Integer;
  Begin
    While Not EoLn(F3) Do
      Begin
        Read(F3,Q);
        If AIDS[Q]=_B Then Done(True);
        AIDS[Q]:=_A;
        Dec(A,Rooms[Q]);
        Rooms[Q]:=0;
      End;
    V:=0;
    For I:=1 To N Do
      If AIDS[I]<>_A Then Inc(V,Rooms[I]);

    Dif:=(A>0) Or (V<B);
    Close(F3);
  End;

Begin
  Init;
  InputData;
  CheckData;
  Done(Dif);
End.